/*
ds14xxe.h
*/

#define DO_RESET		0
#define DO_BIT			1
#define DO_BYTE			2
#define TOGGLE_OVERDRIVE	3
#define TOGGLE_PASSTHRU		4
#define CHECK_BRICK		5
#define DO_BLOCK		6

/* These are on the data register */
#define DS1481_DCLK		0x02 /* D1 */
#define DS1481_RES		0x01 /* D0 */

/* This one is on the control register */
#define DS1481_ENI		0x02 /* /ALF (inverted at pin) */

/* These are on the status register */
#define DS1481_O1BSY		0x80 /* /BSY (inverted at pin) */
#define DS1481_O2BSY		0x10 /* OFON */

#ifndef MIN
#define MIN(x,y)		(x < y)?x:y
#endif

#define DOW_LOW_LATENCY

#ifdef DOW_LOW_LATENCY
#define OUTB(data,port)		outb(data,port)
#define INB(port)		inb(port)
#else
#define OUTB(data,port)		outb_p(data,port)
#define INB(port)		inb_p(port)
#endif

#ifdef DOW_USE_PARPORT

#define PARPORT_NEED_GENERIC_OPS
#include "linux/parport.h"

#define READ_DATA(p)			parport_read_data(dow_parport_table[p].dev->port)
#define WRITE_DATA(data,p)		parport_write_data(dow_parport_table[p].dev->port,data)
#define READ_STATUS(p)			parport_read_status(dow_parport_table[p].dev->port)
#define WRITE_STATUS(data,p)		parport_write_status(dow_parport_table[p].dev->port,data)
#define READ_CONTROL(p)			parport_read_control(dow_parport_table[p].dev->port)
#define WRITE_CONTROL(data,p)		parport_write_control(dow_parport_table[p].dev->port,data)

#else

#define DOW_BASE(minor)		(dow_table[(minor)].base)
#define DOW_STATUS(minor)	(dow_table[(minor)].base+1)
#define DOW_CONTROL(minor)	(dow_table[(minor)].base+2)

#define READ_DATA(minor)		INB(DOW_BASE(minor))
#define WRITE_DATA(data,minor)		OUTB(data,DOW_BASE(minor))
#define READ_STATUS(minor)		INB(DOW_STATUS(minor))
#define WRITE_STATUS(data,minor)	OUTB(data,DOW_STATUS(minor))
#define READ_CONTROL(minor)		INB(DOW_CONTROL(minor))
#define WRITE_CONTROL(data,minor)	OUTB(data,DOW_CONTROL(minor))

#endif
